(function($) {

  $.fn.getAccordionItems = function() {
    return this.find('.accordion-item').not('.accordion-panel');
  };

  // Mark panes or accordion groups as 'filtered' if empty of accordion items
  $.fn.filterEmpty = function() {
    if (this.getAccordionItems().not('.filtered').length == 0) {
      this.addClass('filtered');
    }
    else {
      this.removeClass('filtered');
    }
  }

  $('.l-content').each(function() {
    var container = this;

    // Activate on textfield input
    $('.l-region--content #block-wcm-panels-settings-wcm-accordion-filter .form-text, .l-region--content .pane-wcm-panels-settings-wcm-accordion-filter .form-text', container).on('keyup input', function() {
      // Get search string
      var searchValue = $(this).val().trim().toLowerCase();

      var accordionGroups = $('.accordion', container);
      var accordionPanes = accordionGroups.parents('.panel-pane');
      var accordionItems = accordionGroups.getAccordionItems();

      // If a search value has been entered
      if (searchValue.length > 0) {

        // Loop through all accordion groups
        accordionGroups.each(function() {

          // Loop through each accordion in the group
          $(this).getAccordionItems().each(function() {
            var accordion = $(this);
            var header = accordion.find('.accordion-header').text().toLowerCase();
            var content = accordion.find('.accordion-panel').text().toLowerCase();

            // Add 'filtered' class to any accordion containing searched value
            if (header.indexOf(searchValue) + content.indexOf(searchValue) < -1) {
              accordion.addClass('filtered');
            }
            else {
              accordion.removeClass('filtered');
            }
          });

          // Add 'filtered' class to accordion group if empty
          $(this).filterEmpty();
        });

        // Add 'filtered' class to accordion panes if empty of accordions
        accordionPanes.each(function(){
          $(this).filterEmpty();
        });

        // Show all hidden content
        accordionItems.show();
        accordionGroups.prevUntil('.accordion').show();
        accordionPanes.show();

        // Hide any elements marked as 'filtered'
        accordionItems.filter('.filtered').hide();
        accordionGroups.filter('.filtered').prevUntil('.accordion').hide();
        accordionPanes.filter('.filtered').hide();
      }
      // If no search value has been entered, reset all hidden content
      else {
        accordionItems.removeClass('filtered').show();
        accordionGroups.prevUntil('.accordion').show();
        accordionPanes.removeClass('filtered').show();
      }

      // Show or hide the 'No Results' message, depending on whether any accordions are visible.
      var noResults = $('.accordions-no-results', container);

      if (accordionItems.not('.filtered').length > 0) {
        noResults.hide();
      } else {
        noResults.show();
      }
    });
  });
})(jQuery);
